package at.ssw.visualizer.texteditor.view;

import java.awt.Dimension;
import javax.swing.JComponent;
import javax.swing.text.JTextComponent;
import org.netbeans.api.editor.fold.FoldUtilities;
import org.netbeans.spi.editor.SideBarFactory;

/**
 * This is a workaround for NETBEANS-6232. NB platform wrongly computes sidebar
 * (line numbers, code folding) after fold expansion - until the bug is fixed, this
 * component will force the sidebar's height to the text view's height.
 * It is safe to remove this class + layer.xml registration after NETBEANS-6232 is fixed and
 * the fixed platform is consumed in C1V.
 * @author sdedic
 */
public class PaintBugWorkaroundBar extends JComponent {
    private final JTextComponent target;

    PaintBugWorkaroundBar(JTextComponent target) {
        this.target = target;
    }

    @Override
    public Dimension getPreferredSize() {
        Dimension d = new Dimension();
        d.height = target.getPreferredScrollableViewportSize().height;
        return d;
    }
    
    /**
     * Factory for the sidebars. Use {@link FoldUtilities#getFoldingSidebarFactory()} to
     * obtain an instance.
     */
    public static class Factory implements SideBarFactory {
        @Override
        public JComponent createSideBar(JTextComponent target) {
            return new PaintBugWorkaroundBar(target);
        }
    }
}
